# coding: utf-8

"""
    CardPay REST API

    Welcome to the CardPay REST API. The CardPay API uses HTTP verbs and a [REST](https://en.wikipedia.org/wiki/Representational_state_transfer) resources endpoint structure (see more info about REST). Request and response payloads are formatted as JSON. Merchant uses API to create payments, refunds, payouts or recurrings, check or update transaction status and get information about created transactions. In API authentication process based on [OAuth 2.0](https://oauth.net/2/) standard. For recent changes see changelog section.  # noqa: E501

    OpenAPI spec version: 3.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class PayoutRequestPayoutData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "amount": "float",
        "currency": "str",
        "dynamic_descriptor": "str",
        "encrypted_data": "str",
        "funding_source": "str",
        "generate_token": "bool",
        "network_trans_id": "str",
        "note": "str",
    }

    attribute_map = {
        "amount": "amount",
        "currency": "currency",
        "dynamic_descriptor": "dynamic_descriptor",
        "encrypted_data": "encrypted_data",
        "funding_source": "funding_source",
        "generate_token": "generate_token",
        "network_trans_id": "network_trans_id",
        "note": "note",
    }

    def __init__(
        self,
        amount=None,
        currency=None,
        dynamic_descriptor=None,
        encrypted_data=None,
        funding_source=None,
        generate_token=None,
        network_trans_id=None,
        note=None,
    ):  # noqa: E501
        """PayoutRequestPayoutData - a model defined in Swagger"""  # noqa: E501

        self._amount = None
        self._currency = None
        self._dynamic_descriptor = None
        self._encrypted_data = None
        self._funding_source = None
        self._generate_token = None
        self._network_trans_id = None
        self._note = None
        self.discriminator = None

        self.amount = amount
        self.currency = currency
        if dynamic_descriptor is not None:
            self.dynamic_descriptor = dynamic_descriptor
        if encrypted_data is not None:
            self.encrypted_data = encrypted_data
        if funding_source is not None:
            self.funding_source = funding_source
        if generate_token is not None:
            self.generate_token = generate_token
        if network_trans_id is not None:
            self.network_trans_id = network_trans_id
        if note is not None:
            self.note = note

    @property
    def amount(self):
        """Gets the amount of this PayoutRequestPayoutData.  # noqa: E501

        Represents the amount to be transferred to Customer's card, must be less than 10 billion.  # noqa: E501

        :return: The amount of this PayoutRequestPayoutData.  # noqa: E501
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this PayoutRequestPayoutData.

        Represents the amount to be transferred to Customer's card, must be less than 10 billion.  # noqa: E501

        :param amount: The amount of this PayoutRequestPayoutData.  # noqa: E501
        :type: float
        """
        if amount is None:
            raise ValueError(
                "Invalid value for `amount`, must not be `None`"
            )  # noqa: E501

        self._amount = amount

    @property
    def currency(self):
        """Gets the currency of this PayoutRequestPayoutData.  # noqa: E501

        [ISO 4217](https://en.wikipedia.org/wiki/ISO_4217) currency code of the payout transaction. Must match terminal currency  # noqa: E501

        :return: The currency of this PayoutRequestPayoutData.  # noqa: E501
        :rtype: str
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this PayoutRequestPayoutData.

        [ISO 4217](https://en.wikipedia.org/wiki/ISO_4217) currency code of the payout transaction. Must match terminal currency  # noqa: E501

        :param currency: The currency of this PayoutRequestPayoutData.  # noqa: E501
        :type: str
        """
        if currency is None:
            raise ValueError(
                "Invalid value for `currency`, must not be `None`"
            )  # noqa: E501

        self._currency = currency

    @property
    def dynamic_descriptor(self):
        """Gets the dynamic_descriptor of this PayoutRequestPayoutData.  # noqa: E501

        Short description of the service or product, must be enabled by CardPay manager to be used *(for BANKCARD, QIWI, WEBMONEY methods only)*  # noqa: E501

        :return: The dynamic_descriptor of this PayoutRequestPayoutData.  # noqa: E501
        :rtype: str
        """
        return self._dynamic_descriptor

    @dynamic_descriptor.setter
    def dynamic_descriptor(self, dynamic_descriptor):
        """Sets the dynamic_descriptor of this PayoutRequestPayoutData.

        Short description of the service or product, must be enabled by CardPay manager to be used *(for BANKCARD, QIWI, WEBMONEY methods only)*  # noqa: E501

        :param dynamic_descriptor: The dynamic_descriptor of this PayoutRequestPayoutData.  # noqa: E501
        :type: str
        """
        if dynamic_descriptor is not None and len(dynamic_descriptor) > 25:
            raise ValueError(
                "Invalid value for `dynamic_descriptor`, length must be less than or equal to `25`"
            )  # noqa: E501
        if dynamic_descriptor is not None and len(dynamic_descriptor) < 0:
            raise ValueError(
                "Invalid value for `dynamic_descriptor`, length must be greater than or equal to `0`"
            )  # noqa: E501

        self._dynamic_descriptor = dynamic_descriptor

    @property
    def encrypted_data(self):
        """Gets the encrypted_data of this PayoutRequestPayoutData.  # noqa: E501

        The encrypted payment credentials encoded in base64 *(for APPLEPAY payment method only)*  # noqa: E501

        :return: The encrypted_data of this PayoutRequestPayoutData.  # noqa: E501
        :rtype: str
        """
        return self._encrypted_data

    @encrypted_data.setter
    def encrypted_data(self, encrypted_data):
        """Sets the encrypted_data of this PayoutRequestPayoutData.

        The encrypted payment credentials encoded in base64 *(for APPLEPAY payment method only)*  # noqa: E501

        :param encrypted_data: The encrypted_data of this PayoutRequestPayoutData.  # noqa: E501
        :type: str
        """
        if encrypted_data is not None and len(encrypted_data) > 10000:
            raise ValueError(
                "Invalid value for `encrypted_data`, length must be less than or equal to `10000`"
            )  # noqa: E501
        if encrypted_data is not None and len(encrypted_data) < 0:
            raise ValueError(
                "Invalid value for `encrypted_data`, length must be greater than or equal to `0`"
            )  # noqa: E501

        self._encrypted_data = encrypted_data

    class FundingSource(object):
        CREDIT_CARD = "CREDIT_CARD"
        DEBIT_CARD = "DEBIT_CARD"
        PREPAID_CARD = "PREPAID_CARD"
        DEPOSIT_DEBIT_ACCOUNT = "DEPOSIT_DEBIT_ACCOUNT"
        CREDIT_ACCOUNT = "CREDIT_ACCOUNT"
        MOBILE_MONEY_ACCOUNT = "MOBILE_MONEY_ACCOUNT"
        CASH = "CASH"
        CHECK = "CHECK"
        OTHER = "OTHER"

    @property
    def funding_source(self):
        """Gets the funding_source of this PayoutRequestPayoutData.  # noqa: E501

        Funding source type. Valid values: 01 - Credit card 02 - Debit card 03 - Prepaid card 04 - Deposit/debit account 05 - Credit account 06 - Mobile money account 07 - Cash 08 - Check 09 - Other  # noqa: E501

        :return: The funding_source of this PayoutRequestPayoutData.  # noqa: E501
        :rtype: str
        """
        return self._funding_source

    @funding_source.setter
    def funding_source(self, funding_source):
        """Sets the funding_source of this PayoutRequestPayoutData.

        Funding source type. Valid values: 01 - Credit card 02 - Debit card 03 - Prepaid card 04 - Deposit/debit account 05 - Credit account 06 - Mobile money account 07 - Cash 08 - Check 09 - Other  # noqa: E501

        :param funding_source: The funding_source of this PayoutRequestPayoutData.  # noqa: E501
        :type: str
        """
        allowed_values = [
            "CREDIT_CARD",
            "DEBIT_CARD",
            "PREPAID_CARD",
            "DEPOSIT_DEBIT_ACCOUNT",
            "CREDIT_ACCOUNT",
            "MOBILE_MONEY_ACCOUNT",
            "CASH",
            "CHECK",
            "OTHER",
        ]  # noqa: E501
        if funding_source not in allowed_values:
            raise ValueError(
                "Invalid value for `funding_source` ({0}), must be one of {1}".format(  # noqa: E501
                    funding_source, allowed_values
                )
            )

        self._funding_source = funding_source

    @property
    def generate_token(self):
        """Gets the generate_token of this PayoutRequestPayoutData.  # noqa: E501

        If set to `true`, token will be generated and returned in the response (callback). Token can be generated only for successful transactions (not for declined transactions) *(for BANKCARD payment method only)*  # noqa: E501

        :return: The generate_token of this PayoutRequestPayoutData.  # noqa: E501
        :rtype: bool
        """
        return self._generate_token

    @generate_token.setter
    def generate_token(self, generate_token):
        """Sets the generate_token of this PayoutRequestPayoutData.

        If set to `true`, token will be generated and returned in the response (callback). Token can be generated only for successful transactions (not for declined transactions) *(for BANKCARD payment method only)*  # noqa: E501

        :param generate_token: The generate_token of this PayoutRequestPayoutData.  # noqa: E501
        :type: bool
        """

        self._generate_token = generate_token

    @property
    def network_trans_id(self):
        """Gets the network_trans_id of this PayoutRequestPayoutData.  # noqa: E501

        Network Reference Number of original transaction  # noqa: E501

        :return: The network_trans_id of this PayoutRequestPayoutData.  # noqa: E501
        :rtype: str
        """
        return self._network_trans_id

    @network_trans_id.setter
    def network_trans_id(self, network_trans_id):
        """Sets the network_trans_id of this PayoutRequestPayoutData.

        Network Reference Number of original transaction  # noqa: E501

        :param network_trans_id: The network_trans_id of this PayoutRequestPayoutData.  # noqa: E501
        :type: str
        """

        self._network_trans_id = network_trans_id

    @property
    def note(self):
        """Gets the note of this PayoutRequestPayoutData.  # noqa: E501

        Note about the payout, not shown to Customer  # noqa: E501

        :return: The note of this PayoutRequestPayoutData.  # noqa: E501
        :rtype: str
        """
        return self._note

    @note.setter
    def note(self, note):
        """Sets the note of this PayoutRequestPayoutData.

        Note about the payout, not shown to Customer  # noqa: E501

        :param note: The note of this PayoutRequestPayoutData.  # noqa: E501
        :type: str
        """
        if note is not None and len(note) > 100:
            raise ValueError(
                "Invalid value for `note`, length must be less than or equal to `100`"
            )  # noqa: E501
        if note is not None and len(note) < 0:
            raise ValueError(
                "Invalid value for `note`, length must be greater than or equal to `0`"
            )  # noqa: E501

        self._note = note

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                if value is not None:
                    result[attr] = value
        if issubclass(PayoutRequestPayoutData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PayoutRequestPayoutData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
